/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** misc.c
 **
 ** Made by (Julien Mulot)
 ** Login   <mulot@epita.fr>
 **
 ** Started on  Fri Jan  8 21:16:10 1999 Julien Mulot
 ** Last update Tue Aug 10 00:33:42 1999 Julien Mulot
 */

#include "epiwm.h"

void		add_elt(new_win)
t_win		*new_win;
{
  t_win_list	*tmp_elt;
  
  if (gl_epiwin.align_btn_max == 0)
    new_win->button_max = 0;
  if (gl_epiwin.align_btn_iconify == 0)
    new_win->button_iconify = 0;
  if (gl_epiwin.align_btn_max_height == 0)
    new_win->button_max_height = 0;
  if (gl_epiwin.align_btn_max_width == 0)
    new_win->button_max_width = 0;
  if (gl_epiwin.align_btn_close == 0)
    new_win->button_close = 0;
  if (gl_epiwin.align_btn_shade == 0)
    new_win->button_shade = 0;
  new_win->iconify_title_win = 0;
  new_win->is_shade = 0;
  new_win->is_max_width = 0;
  new_win->is_max_height = 0;
  new_win->is_max = 0;
  new_win->win_width = 0;
  new_win->win_height = 0;
  new_win->shade_width = 0;
  new_win->shade_height = 0;  
  tmp_elt = (t_win_list *) malloc(sizeof(t_win_list));
  tmp_elt->p_t_win = new_win;
  tmp_elt->next_elt = NULL;
  if (gl_epiwin.first_win_group_list == NULL)
    {
      gl_epiwin.first_win_group_list = tmp_elt;
      gl_epiwin.nb_elt = 1;
    }
  else
    {
      tmp_elt->next_elt = gl_epiwin.first_win_group_list;
      gl_epiwin.first_win_group_list = tmp_elt;
      gl_epiwin.nb_elt++;
    }
}


t_win		*search_elt(w)
Window          w;
{
  t_win_list	*temp;
   
  if (w == 0)
    return (NULL);
  if (gl_epiwin.first_win_group_list)
    {
      temp = gl_epiwin.first_win_group_list;
      while (temp->next_elt && !(search_win(temp->p_t_win, w)))
	temp = temp->next_elt;
      if (search_win(temp->p_t_win, w))
	return (temp->p_t_win);
    }
  return (NULL);
}

void		remove_elt(w)
Window		w;
{
  t_win_list	*temp;
  t_win_list   *before;
  
  if (gl_epiwin.first_win_group_list)
    {
      temp = gl_epiwin.first_win_group_list;
      before = NULL;
      while (temp->next_elt && !(search_win(temp->p_t_win, w)))
	{
	  before = temp;
	  temp = temp->next_elt;
	}
      if (search_win(temp->p_t_win, w))
	{
	  if (before)
	    before->next_elt = temp->next_elt;
	  else
	    gl_epiwin.first_win_group_list = temp->next_elt;
	  free(temp->p_t_win);
	  free(temp);
	  gl_epiwin.nb_elt--;
	}
    }
}

int	search_win(tmp, win)
t_win	*tmp;
Window	win;
{
  return ((tmp->win == win) ||
	  (tmp->parent == win) ||
	  (tmp->border_frame == win) ||
	  (tmp->titlebar_win == win) ||
	  (tmp->button_close == win) ||
	  (tmp->button_max_height == win) ||
	  (tmp->button_max_width == win) ||
	  (tmp->button_max == win) ||
	  (tmp->button_shade == win) ||
	  (tmp->button_iconify == win) ||
	  (tmp->iconify_title_win == win) ||	  
	  (tmp->iconify_win == win));
}



