/*
 **  EPIwm
 **  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
 **
 **  This program is free software; you can redistribute it and/or modify
 **  it under the terms of the GNU General Public License as published by
 **  the Free Software Foundation; either version 2 of the License, or
 **  (at your option) any later version.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **
 **  You should have received a copy of the GNU General Public License
 **  along with this program; if not, write to the Free Software
 **  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **
 ** mouse_resize.c
 ** 
 ** Made by (Thomas Poindessous)
 ** Login   <poinde_t@epita.fr>
 ** 
 ** Started on  Mon Jun  7 17:45:19 1999 Thomas Poindessous
 ** Last update Sun Jul 25 21:19:07 1999 Thomas Poindessous
 */

#include "epiwm.h"


void			mouse_resize_max(list)
t_mouse_move_win	*list;
{
  if ((!(verify_mouse_vs_button(list->button->x, list->button->y))) || (!list))
    return ;
  if (list->temp->is_max)
    internal_resize_unmax(list->temp);
  else
    internal_resize_max(list->temp); 
  if (test_shape(list->temp->win) || gl_epiwin.titlebar.width_mode)
    {
      gl_event.xmap.window = list->temp->win;
      map_win();
    }
}

void			mouse_shade(list)
t_mouse_move_win	*list;
{  
  if (!list)
    return ;
  if (list->temp->is_shade == 0)
    list->temp->is_shade = 1;
  else if (list->temp->is_shade == 1)
    {
      if ((gl_win_move.bef == gl_win_move.win)
	  && ((list->button->time - gl_win_move.last) < TIME_TWO_CLICKS))
	internal_shade(list->temp);
      else
	list->temp->is_shade = 0;
    }
  else if (list->temp->is_shade == 2)
    list->temp->is_shade = 3;
  else if (list->temp->is_shade == 3)
    {
      if ((gl_win_move.bef == gl_win_move.win) &&
	  ((list->button->time - gl_win_move.last) < TIME_TWO_CLICKS))
	internal_unshade(list->temp);
      else
	list->temp->is_shade = 2;
    }
  else
    list->temp->is_shade = 2;
  if ((gl_epiwin.titlebar.width))
    if (list->temp->is_shade == 2 || list->temp->is_shade == 0)
      draw_titlebar_shape(list->temp);
}


void			win_max_width(wg_tmp)
t_win			*wg_tmp;
{
  if (wg_tmp->is_max_width)
    internal_unmax_width(wg_tmp);
  else
    internal_max_width(wg_tmp);
  if (gl_epiwin.titlebar.width)
    draw_titlebar_shape(wg_tmp);
}

void			win_max_height(wg_tmp)
t_win			*wg_tmp;
{
  if (wg_tmp->is_max_height)
    internal_unmax_height(wg_tmp);
  else
    internal_max_height(wg_tmp);
  if (gl_epiwin.titlebar.width)
    draw_titlebar_shape(wg_tmp);
}

int	verify_mouse_vs_button(x, y)
int	x;
int	y;
{
  if ((x < 0) || (y < 0) || (x > gl_epiwin.btn_width)
      || (y > gl_epiwin.btn_height))
    return (0);
  else
    return (1);
}

void	internal_resize_unmax(wg_tmp)
t_win	*wg_tmp;
{    
  if (!wg_tmp)
    return ;
  wg_tmp->is_max = 0;
  if ((wg_tmp->is_shade == 2) || (wg_tmp->is_shade == 3))
    {
      if (gl_epiwin.titlebar.position == TOP
	  || gl_epiwin.titlebar.position == BOTTOM)
	{
	  if (wg_tmp->is_max_width && wg_tmp->is_max_height)
	    return ;
	  if (wg_tmp->is_max_width)	    
	    XMoveWindow(gl_dpy, wg_tmp->parent, 0, wg_tmp->win_y);
	  else if (wg_tmp->is_max_height)
	    {
	      XMoveResizeWindow(gl_dpy, wg_tmp->titlebar_win,
				0, 0, wg_tmp->win_width -
				2 * wg_tmp->titlebar_border,
				wg_tmp->titlebar_height);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent, wg_tmp->win_x, 0,
				wg_tmp->win_width,
				wg_tmp->titlebar_height +
				2*wg_tmp->titlebar_border);
	    }
	  else
	    {
	      XMoveResizeWindow(gl_dpy, wg_tmp->titlebar_win,
				0, 0, wg_tmp->win_width -
				2 * wg_tmp->titlebar_border,
				wg_tmp->titlebar_height);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent, wg_tmp->win_x,
				wg_tmp->win_y,
				wg_tmp->win_width,
				wg_tmp->titlebar_height +
				2*wg_tmp->titlebar_border);
	    }
	}
      else if (gl_epiwin.titlebar.position == RIGHT
	       || gl_epiwin.titlebar.position == LEFT)
	{
	  if (wg_tmp->is_max_width && wg_tmp->is_max_width)
	    return ;
	  if (wg_tmp->is_max_width)
	    {
	      
	      XMoveResizeWindow(gl_dpy, wg_tmp->titlebar_win,
				0, 0, wg_tmp->titlebar_height,
				wg_tmp->win_height
				- 2*wg_tmp->titlebar_border);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent, 0, wg_tmp->win_y,
				wg_tmp->titlebar_height +
				2*wg_tmp->titlebar_border,
				wg_tmp->win_height);
	    }
	  else if (wg_tmp->is_max_height)
	    {
	      XMoveResizeWindow(gl_dpy, wg_tmp->titlebar_win,
				0, 0, wg_tmp->titlebar_height,
				gl_scr_info.dpy_height
				- 2*wg_tmp->titlebar_border);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent, wg_tmp->win_x, 0,
				wg_tmp->titlebar_height +
				2*wg_tmp->titlebar_border,
				gl_scr_info.dpy_height);
	    }
	  else
	    {
	      XMoveResizeWindow(gl_dpy, wg_tmp->titlebar_win,
				0, 0, wg_tmp->titlebar_height,
				wg_tmp->win_height
				- 2*wg_tmp->titlebar_border);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent, wg_tmp->win_x,
				wg_tmp->win_y,
				wg_tmp->titlebar_height +
				2*wg_tmp->titlebar_border,
				wg_tmp->win_height);
	    }
	}
      internal_replace_button(wg_tmp);
    }
  else
    {
      if (wg_tmp->is_max_width && wg_tmp->is_max_height)
	return ;
      if (wg_tmp->is_max_width)
	window_group_resize(wg_tmp, 0, wg_tmp->win_y,
			    gl_scr_info.dpy_width,
			    wg_tmp->win_height);
      else if (wg_tmp->is_max_height)
	window_group_resize(wg_tmp, wg_tmp->win_x, 0,
			    wg_tmp->win_width,
			    gl_scr_info.dpy_height);
      else
	window_group_resize(wg_tmp, wg_tmp->win_x,
			    wg_tmp->win_y,
			    wg_tmp->win_width,
			    wg_tmp->win_height);
    }
  send_configure_notify(wg_tmp);
}

void		internal_resize_max(wg_tmp)
t_win		*wg_tmp;
{
  int		x;
  int		y;
  int		width;
  int		height;
  Window	dummy_win;
  unsigned int	dummy;
  
  if (!wg_tmp)
    return ;  
  wg_tmp->is_max = 1;
  XGetGeometry(gl_dpy, wg_tmp->parent, &dummy_win, &x, &y,
	       &width, &height, &dummy, &dummy);
  if ((wg_tmp->is_max_width || wg_tmp->is_max_height) == 0)
    {
      wg_tmp->win_x = x;
      wg_tmp->win_y = y;
    }
  if ((wg_tmp->is_shade == 2) || (wg_tmp->is_shade == 3))
    {
      if (wg_tmp->is_max_width == 0)
	wg_tmp->win_width = wg_tmp->shade_width;
      if (wg_tmp->is_max_height == 0)
	wg_tmp->win_height = wg_tmp->shade_height;
      if (gl_epiwin.titlebar.position == TOP)
	{
	  XResizeWindow(gl_dpy, wg_tmp->titlebar_win,
			gl_scr_info.dpy_width -
			2 * wg_tmp->titlebar_border,
			wg_tmp->titlebar_height);
	  XMoveResizeWindow(gl_dpy, wg_tmp->parent, 0, 0,		 
			    gl_scr_info.dpy_width,
			    wg_tmp->titlebar_height +
			    2*wg_tmp->titlebar_border);
	}
      else if (gl_epiwin.titlebar.position == BOTTOM)
	{
	  XMoveResizeWindow(gl_dpy, wg_tmp->titlebar_win,
			    0, 0, gl_scr_info.dpy_width -
			    2 * wg_tmp->titlebar_border,
			    wg_tmp->titlebar_height);
	  XMoveResizeWindow(gl_dpy, wg_tmp->parent, 0, gl_scr_info.dpy_height
			    - ( wg_tmp->titlebar_height +
			       2 * wg_tmp->titlebar_border),
			    gl_scr_info.dpy_width,
			    wg_tmp->titlebar_height +
			    2*wg_tmp->titlebar_border);
	}
      else if (gl_epiwin.titlebar.position == LEFT)
	{
	  XResizeWindow(gl_dpy, wg_tmp->titlebar_win,
			wg_tmp->titlebar_height,
			gl_scr_info.dpy_height -
			2 * wg_tmp->titlebar_border);
	  XMoveResizeWindow(gl_dpy, wg_tmp->parent, 0, 0,		 
			    wg_tmp->titlebar_height +
			    2*wg_tmp->titlebar_border,
			    gl_scr_info.dpy_height);
	}
      else if (gl_epiwin.titlebar.position == RIGHT)
	{
	  XMoveResizeWindow(gl_dpy, wg_tmp->titlebar_win,
			    0, 0,
			    wg_tmp->titlebar_height,
			    gl_scr_info.dpy_height -
			    2 * wg_tmp->titlebar_border);
	  XMoveResizeWindow(gl_dpy, wg_tmp->parent, gl_scr_info.dpy_width -
			    (wg_tmp->titlebar_height +
			     2 *(wg_tmp->titlebar_border)),
			    0, wg_tmp->titlebar_height +
			    2 * wg_tmp->titlebar_border,
			    gl_scr_info.dpy_height);
	}
      internal_replace_button(wg_tmp);
    }
  else
    {
      if (wg_tmp->is_max_width == 0)
	wg_tmp->win_width = width;
      if (wg_tmp->is_max_height == 0)
	wg_tmp->win_height = height;
      window_group_resize(wg_tmp, 0, 0,
			  gl_scr_info.dpy_width,
			  gl_scr_info.dpy_height);
      send_configure_notify(wg_tmp);
    } 
}

void		internal_shade(wg_tmp)
t_win		*wg_tmp;
{
  int		x;
  int		y;
  int		width;
  int		height;
  Window	dummy_win;
  unsigned int	dummy;
  
  wg_tmp->is_shade = 2;
  if (wg_tmp->is_max)
    {
      wg_tmp->shade_width = wg_tmp->win_width;
      wg_tmp->shade_height = wg_tmp->win_height;
      if (gl_epiwin.titlebar.position == TOP)
	XResizeWindow(gl_dpy, wg_tmp->parent,
		      gl_scr_info.dpy_width,
		      wg_tmp->titlebar_height +
		      2*wg_tmp->titlebar_border);
      else if (gl_epiwin.titlebar.position == BOTTOM)
	{
	  XMoveResizeWindow(gl_dpy, wg_tmp->parent,
			    0, gl_scr_info.dpy_height -
			    wg_tmp->titlebar_height +
			    2*wg_tmp->titlebar_border,
			    gl_scr_info.dpy_width,
			    wg_tmp->titlebar_height +
			    2*wg_tmp->titlebar_border);
	  XMoveWindow(gl_dpy, wg_tmp->titlebar_win, 0, 0);
	}
      else if (gl_epiwin.titlebar.position == LEFT)
	XResizeWindow(gl_dpy, wg_tmp->parent,
		      wg_tmp->titlebar_height +
		      2*wg_tmp->titlebar_border,
		      gl_scr_info.dpy_height);
      else if (gl_epiwin.titlebar.position == RIGHT)
	{
	  XMoveResizeWindow(gl_dpy, wg_tmp->parent,
			    gl_scr_info.dpy_width -
			    wg_tmp->titlebar_height +
			    2*wg_tmp->titlebar_border,
			    0, wg_tmp->titlebar_height +
			    2*wg_tmp->titlebar_border,
			    gl_scr_info.dpy_height);
	  XMoveWindow(gl_dpy, wg_tmp->titlebar_win, 0, 0);
	}
      internal_replace_button(wg_tmp);
    }
  else
    {
      XGetGeometry(gl_dpy, wg_tmp->parent, &dummy_win, &x, &y,
		   &width, &height, &dummy, &dummy);
      if (wg_tmp->is_max_width)
	wg_tmp->shade_width = wg_tmp->win_width;
      else
	{
	  wg_tmp->win_x = x;
	  wg_tmp->shade_width = width;
	}
      if (wg_tmp->is_max_height)
	wg_tmp->shade_height = wg_tmp->win_height;
      else
	{
	  wg_tmp->win_y = y;
	  wg_tmp->shade_height = height;
	}
      if (!(wg_tmp->is_max_width || wg_tmp->is_max_height
	    || wg_tmp->is_max))
	{
	  wg_tmp->win_x = x;
	  wg_tmp->win_y = y;
	  wg_tmp->win_width = width;
	  wg_tmp->win_height = height;
	}
      if (gl_epiwin.titlebar.position == TOP)
	XResizeWindow(gl_dpy, wg_tmp->parent,
		      width,
		      wg_tmp->titlebar_height
		      + 2*wg_tmp->titlebar_border);
      else if (gl_epiwin.titlebar.position == BOTTOM)
	{
	  XMoveResizeWindow(gl_dpy, wg_tmp->parent,
			    x, y + height -
			    (wg_tmp->titlebar_height +
			     2*wg_tmp->titlebar_border),
			    width, wg_tmp->titlebar_height
			    + 2*wg_tmp->titlebar_border);
	  XMoveWindow(gl_dpy, wg_tmp->titlebar_win, 0, 0);
	}
      else if (gl_epiwin.titlebar.position == LEFT)
	XResizeWindow(gl_dpy, wg_tmp->parent,
		      wg_tmp->titlebar_height
		      + 2*wg_tmp->titlebar_border,
		      height);
      else if (gl_epiwin.titlebar.position == RIGHT)
	{
	  XMoveResizeWindow(gl_dpy, wg_tmp->parent,
			    x + width -
			    (wg_tmp->titlebar_height
			     + 2*wg_tmp->titlebar_border), y,
			    wg_tmp->titlebar_height			    
			    + 2*wg_tmp->titlebar_border, height);
	  XMoveWindow(gl_dpy, wg_tmp->titlebar_win, 0, 0);
	}
      internal_replace_button(wg_tmp);
    }
}

void		internal_unshade(wg_tmp)
t_win		*wg_tmp;
{
  int		x;
  int		y;
  int		width;
  int		height;
  Window	dummy_win;
  unsigned int	dummy;
  
  wg_tmp->is_shade = 0;
  XGetGeometry(gl_dpy, wg_tmp->parent, &dummy_win, &x, &y,
	       &width, &height, &dummy, &dummy);
  if (wg_tmp->is_max)
    {
      window_group_resize(wg_tmp, x, y,  gl_scr_info.dpy_width,
			  gl_scr_info.dpy_height);
      send_configure_notify(wg_tmp);
    }
  else
    {      
      if (wg_tmp->is_max_width)
	{
	  if (wg_tmp->is_max_height)
	    window_group_resize(wg_tmp, x, y, gl_scr_info.dpy_width,
				gl_scr_info.dpy_height);
	  else
	    {
	      if (gl_epiwin.titlebar.position == BOTTOM)
		window_group_resize(wg_tmp, x, y - wg_tmp->shade_height
				    - 2 * wg_tmp->titlebar_border
				    - wg_tmp->titlebar_height,
				    gl_scr_info.dpy_width,
				    wg_tmp->shade_height);
	      else if (gl_epiwin.titlebar.position == RIGHT)
		window_group_resize(wg_tmp, x - gl_scr_info.dpy_width + width,
				    y, gl_scr_info.dpy_width,
				    wg_tmp->shade_height);
	      
	      else
		window_group_resize(wg_tmp, x, y,
				    gl_scr_info.dpy_width,
				    wg_tmp->shade_height);
	    }
	}
      else if (wg_tmp->is_max_height)
	{
	  if ((gl_epiwin.titlebar.position == BOTTOM))
	    window_group_resize(wg_tmp, x, y - gl_scr_info.dpy_height + height,
				wg_tmp->shade_width,
				gl_scr_info.dpy_height);
	  else if (gl_epiwin.titlebar.position == RIGHT)
	    window_group_resize(wg_tmp, x - wg_tmp->shade_width + width, y,
				wg_tmp->shade_width,
				gl_scr_info.dpy_height);
	  else
	    window_group_resize(wg_tmp, x, y, wg_tmp->shade_width,
				gl_scr_info.dpy_height);
	}
      else
	{
	  if ((gl_epiwin.titlebar.position == BOTTOM))
	    window_group_resize(wg_tmp, x, y - wg_tmp->shade_height + height,
				wg_tmp->shade_width,
				wg_tmp->shade_height);
	  else if (gl_epiwin.titlebar.position == RIGHT)
	    window_group_resize(wg_tmp, x - wg_tmp->shade_width + width, y,
				wg_tmp->shade_width,
				wg_tmp->shade_height);
	  else
	    window_group_resize(wg_tmp, x, y, wg_tmp->shade_width,
				wg_tmp->shade_height);
	}
      send_configure_notify(wg_tmp);
    }
}

void		internal_max_width(wg_tmp)
t_win		*wg_tmp;
{
  int		x;
  int		y;
  int		width;
  int		height;
  Window	dummy_win;
  unsigned int	dummy;
  
  wg_tmp->is_max_width = 1;
  if (!(wg_tmp->is_max_height || wg_tmp->is_shade || wg_tmp->is_max))
    {
      XGetGeometry(gl_dpy, wg_tmp->parent, &dummy_win, &x, &y,
		   &width, &height, &dummy, &dummy);
      wg_tmp->win_x = x;
      wg_tmp->win_y = y;
      wg_tmp->win_width = width;
      wg_tmp->win_height = height;
    }
  if (wg_tmp->is_max == 0) 	         
    {
      XGetGeometry(gl_dpy, wg_tmp->parent, &dummy_win, &x, &y,
		   &width, &height, &dummy, &dummy);
      if ((wg_tmp->is_shade == 2) || (wg_tmp->is_shade == 3))
	{
	  if (gl_epiwin.titlebar.position == LEFT)
	    {
	      XResizeWindow(gl_dpy, wg_tmp->titlebar_win,
			    wg_tmp->titlebar_height,
			    height - 2*wg_tmp->titlebar_border);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent, 0, y,
				wg_tmp->titlebar_height +
				2*wg_tmp->titlebar_border,
				height);
	    }
	  else if (gl_epiwin.titlebar.position == RIGHT)
	    {
	      XMoveResizeWindow(gl_dpy, wg_tmp->titlebar_win, 0, 0,
				wg_tmp->titlebar_height,
				height - 2*wg_tmp->titlebar_border);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent, gl_scr_info.dpy_width -
				(wg_tmp->titlebar_height +
				 2 * (wg_tmp->titlebar_border)),
				y, wg_tmp->titlebar_height +
				2 * wg_tmp->titlebar_border,
				height);
	    }
	  else if (gl_epiwin.titlebar.position == TOP)
	    {
	      XResizeWindow(gl_dpy, wg_tmp->titlebar_win,
			    gl_scr_info.dpy_width
			    - 2*wg_tmp->titlebar_border,
			    wg_tmp->titlebar_height);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent, 0, y,
				gl_scr_info.dpy_width,
				height);
	    }
	  else if (gl_epiwin.titlebar.position == BOTTOM)
	    {
	      XMoveResizeWindow(gl_dpy, wg_tmp->titlebar_win, 0, 0,
				gl_scr_info.dpy_width
				- 2*wg_tmp->titlebar_border,
				wg_tmp->titlebar_height);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent, 0, y,
				gl_scr_info.dpy_width,
				height);
	    }
	  internal_replace_button(wg_tmp);
	}
      else
	window_group_resize(wg_tmp, 0, y,
			    gl_scr_info.dpy_width,
			    height);
      send_configure_notify(wg_tmp);
    }
}

void		internal_unmax_width(wg_tmp)
t_win		*wg_tmp;
{
  int		x;
  int		y;
  int		width;
  int		height;
  Window	dummy_win;
  unsigned int	dummy;
  
  wg_tmp->is_max_width = 0;
  if (wg_tmp->is_max == 0)
    {
      XGetGeometry(gl_dpy, wg_tmp->parent, &dummy_win, &x, &y,
		   &width, &height, &dummy, &dummy);
      if ((wg_tmp->is_shade == 2) || (wg_tmp->is_shade == 3))
	{
	  if (gl_epiwin.titlebar.position == TOP)
	    {
	      XResizeWindow(gl_dpy, wg_tmp->titlebar_win,
			    wg_tmp->win_width -			
			    2*wg_tmp->titlebar_border,
			    wg_tmp->titlebar_height);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent,
				wg_tmp->win_x, y,
				wg_tmp->win_width,
				height);
	    }
	  else if (gl_epiwin.titlebar.position == BOTTOM)
	    {
	      XMoveResizeWindow(gl_dpy, wg_tmp->titlebar_win,
				0, 0, wg_tmp->win_width -
				2*wg_tmp->titlebar_border,
				wg_tmp->titlebar_height);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent,
				wg_tmp->win_x, y,
				wg_tmp->win_width,
				height);
	    }
	  else if (gl_epiwin.titlebar.position == LEFT)
	    {
	      XResizeWindow(gl_dpy, wg_tmp->titlebar_win,
			    wg_tmp->titlebar_height,
			    height - 2*wg_tmp->titlebar_border);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent,		    
				wg_tmp->win_x, y,
				wg_tmp->titlebar_height +
				2*wg_tmp->titlebar_border,
				height);
	    }
	  else if (gl_epiwin.titlebar.position == RIGHT)
	    {
	      XMoveResizeWindow(gl_dpy, wg_tmp->titlebar_win,
				0, 0, wg_tmp->titlebar_height,
				height - 2*wg_tmp->titlebar_border);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent,
				wg_tmp->win_x + wg_tmp->win_width
				- (wg_tmp->titlebar_height +
				   2*wg_tmp->titlebar_border), y,
				wg_tmp->titlebar_height +
				2*wg_tmp->titlebar_border,
				height);
	    }
	  internal_replace_button(wg_tmp);
	}
      else if (wg_tmp->is_max_height)
	window_group_resize(wg_tmp, wg_tmp->win_x, y,
			    wg_tmp->win_width,
			    gl_scr_info.dpy_height);
      else	    
	window_group_resize(wg_tmp, wg_tmp->win_x, y,
			    wg_tmp->win_width,
			    height);
      send_configure_notify(wg_tmp);
    }
}

void		internal_max_height(wg_tmp)
t_win		*wg_tmp;
{
  int		x;
  int		y;
  int		width;
  int		height;
  Window	dummy_win;
  unsigned int	dummy;
  
  wg_tmp->is_max_height = 1;
  if (!(wg_tmp->is_max_width || wg_tmp->is_shade || wg_tmp->is_max))
    {
      XGetGeometry(gl_dpy, wg_tmp->parent, &dummy_win, &x, &y,
		   &width, &height, &dummy, &dummy);
      wg_tmp->win_x = x;
      wg_tmp->win_y = y;
      wg_tmp->win_width = width;
      wg_tmp->win_height = height;
    }
  if (wg_tmp->is_max == 0) 	         
    {
      XGetGeometry(gl_dpy, wg_tmp->parent, &dummy_win, &x, &y,
		   &width, &height, &dummy, &dummy);
      if ((wg_tmp->is_shade == 2) || (wg_tmp->is_shade == 3))
	{
	  if (gl_epiwin.titlebar.position == TOP)
	    XMoveWindow(gl_dpy, wg_tmp->parent, x, 0);	    
	  else if (gl_epiwin.titlebar.position == BOTTOM)
	    XMoveWindow(gl_dpy, wg_tmp->parent, x,
			gl_scr_info.dpy_height -
			(wg_tmp->titlebar_height
			 + 2 * wg_tmp->titlebar_border));
	  else if (gl_epiwin.titlebar.position == LEFT)
	    {
	      XResizeWindow(gl_dpy, wg_tmp->titlebar_win,
			    wg_tmp->titlebar_height,
			    gl_scr_info.dpy_height
			    - 2 * (wg_tmp->titlebar_border));
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent,
				x, 0,
				wg_tmp->titlebar_height +
				2*wg_tmp->titlebar_border,
				gl_scr_info.dpy_height);
	    }
	  else if (gl_epiwin.titlebar.position == RIGHT)
	    {
	      XMoveResizeWindow(gl_dpy, wg_tmp->titlebar_win,
				0, 0, wg_tmp->titlebar_height,
				gl_scr_info.dpy_height
				- 2 * (wg_tmp->titlebar_border));
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent,
				x, 0,
				wg_tmp->titlebar_height +
				2*wg_tmp->titlebar_border,
				gl_scr_info.dpy_height);
	    }
	  internal_replace_button(wg_tmp);
	}
      else
	window_group_resize(wg_tmp, x, 0, width,
			    gl_scr_info.dpy_height);
      send_configure_notify(wg_tmp);
    }
}

void		internal_unmax_height(wg_tmp)
t_win		*wg_tmp;
{
  int		x;
  int		y;
  int		width;
  int		height;
  Window	dummy_win;
  unsigned int	dummy;
  
  wg_tmp->is_max_height = 0;
  if (wg_tmp->is_max == 0)
    {
      XGetGeometry(gl_dpy, wg_tmp->parent, &dummy_win, &x, &y,
		   &width, &height, &dummy, &dummy);
      if ((wg_tmp->is_shade == 2) || (wg_tmp->is_shade == 3))
	{
	  if (gl_epiwin.titlebar.position == TOP)
	    XMoveWindow(gl_dpy, wg_tmp->parent,
			x, wg_tmp->win_y);
       	  else if (gl_epiwin.titlebar.position == BOTTOM)
	    XMoveWindow(gl_dpy, wg_tmp->parent,
			x, wg_tmp->win_y + wg_tmp->shade_height);
       	  else if (gl_epiwin.titlebar.position == LEFT)
	    {
	      XResizeWindow(gl_dpy, wg_tmp->titlebar_win,
			    wg_tmp->titlebar_height,
			    wg_tmp->win_height - 2*wg_tmp->titlebar_border);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent,		    
				x, wg_tmp->win_y,
				wg_tmp->titlebar_height +
				2*wg_tmp->titlebar_border,
				wg_tmp->win_height);
	    }
	  else if (gl_epiwin.titlebar.position == RIGHT)
	    {
	      XMoveResizeWindow(gl_dpy, wg_tmp->titlebar_win,
				0, 0, wg_tmp->titlebar_height,
				wg_tmp->win_height -
				2*wg_tmp->titlebar_border);
	      XMoveResizeWindow(gl_dpy, wg_tmp->parent,
				x + width - (wg_tmp->titlebar_height +
					     2*wg_tmp->titlebar_border),
				wg_tmp->win_y,
				wg_tmp->titlebar_height +
				2*wg_tmp->titlebar_border,
				wg_tmp->win_height);
	    }
	  internal_replace_button(wg_tmp);
	}
      else if (wg_tmp->is_max_width)
	window_group_resize(wg_tmp, x, wg_tmp->win_y,
			    gl_scr_info.dpy_width,
			    wg_tmp->win_height);
      else	    
	window_group_resize(wg_tmp, x, wg_tmp->win_y,
			    width,
			    wg_tmp->win_height);
      send_configure_notify(wg_tmp);
    }
}


